/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;
import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;
import java.io.BufferedReader;
import java.io.StringReader;

public class CheeseMapNavigator extends JDialog implements ActionListener, ListSelectionListener {
	JTextField distance, search;
	JList search_results;
	DefaultListModel list_data = new DefaultListModel();
	
	CheeseMapNavigator( Frame owner ) {
		//super( owner, true );
		setTitle( "Navigator" );
		
		distance = new JTextField( "5" );
		
		Container mainpane = getContentPane();
		mainpane.setLayout( new BoxLayout( mainpane, BoxLayout.PAGE_AXIS ) );
		
		JPanel cpane = new JPanel();
		cpane.setLayout( new GridLayout( 4, 3 ) );
		
		JButton button;
		
		cpane.add( new JLabel() );
		cpane.add( button = new JButton( "N" ) );
		button.addActionListener( this );
		cpane.add( button = new JButton( "U" ) );
		button.addActionListener( this );

		cpane.add( button = new JButton( "W" ) );
		button.addActionListener( this );
		cpane.add( distance );
		cpane.add( button = new JButton( "E" ) );
		button.addActionListener( this );

		cpane.add( new JLabel() );
		cpane.add( button = new JButton( "S" ) );
		button.addActionListener( this );
		cpane.add( button = new JButton( "D" ) );
		button.addActionListener( this );
		
		cpane.add( new JLabel( "Search:" ) );
		cpane.add( search = new JTextField() );
		cpane.add( button = new JButton( "Go" ) );
		button.addActionListener( this );
		
		cpane.setMaximumSize( new Dimension( Integer.MAX_VALUE, 100 ) );
		mainpane.add( cpane );
		
		search_results = new JList( list_data );
		search_results.addListSelectionListener( this );
		search_results.setMaximumSize( new Dimension( Integer.MAX_VALUE, Integer.MAX_VALUE ) );
		JScrollPane sp = new JScrollPane( search_results );
		mainpane.add( sp );
		
		
		pack();
	}
	
	public void actionPerformed( ActionEvent e ) {
		CheeseLab.dmesg( 2, "Move" );
		
		JButton b = (JButton)e.getSource();
		String dir = b.getLabel().toLowerCase();
		
		CheeseLab.dmesg( 3, "  > " + dir );
		
		if( dir.equals( "go" ) ) {
			CheeseMap.send_tx( 1, "search", search.getText() );
		}else{
			int offset = 1;
			try {
				offset = Integer.parseInt( distance.getText() );
			}catch( Exception ee ) {
				ee.printStackTrace();
			}
			
			int x = 0,
				y = 0,
				z = 0;
			
			if( dir.startsWith( "n" ) ) {
				y -= offset;
			}else if( dir.startsWith( "s" ) ) {
				y += offset;
			}else if( dir.startsWith( "e" ) ) {
				x += offset;
			}else if( dir.startsWith( "w" ) ) {
				x -= offset;
			}else if( dir.startsWith( "u" ) ) {
				z++;
			}else if( dir.startsWith( "d" ) ) {
				z--;	
			}
		
			CheeseMap.set_follow_player( false );
			CheeseMap.canvas.move_origin( x, y, z );
		}
	}

	public void valueChanged( ListSelectionEvent e ) {
		if( e.getValueIsAdjusting() == false ) {
			String value = (String)search_results.getSelectedValue();
			if( value != null ) {
				CheeseLab.dmesg( 3, "Search list value changed: " + value );
				search_results.clearSelection();
				
				// Get the roomid then select and move there
				int roomid = 0;
				
				value = value.substring( 1, value.indexOf( " " ) );
				roomid = Integer.parseInt( value );
				
				CheeseLab.dmesg( 3, "Got " + roomid + " from " + value );
				if( roomid != 0 ) {
					CheeseMap.set_edit_room( roomid );
				}
			}
		}
	}
	
	public void set_search_results( byte[] b ) {
		CheeseLab.dmesg( 2, "Accepting search results" );
		list_data.clear();
		
		String s = new String( b );
		BufferedReader in = new BufferedReader( new StringReader( s ) );
		String line;
		try{
			while( (line = in.readLine()) != null ) {
				String[] values = line.split( "," );
				list_data.addElement( "#" + values[ 0 ] + " - " + values[ 1 ] );
			}
			search_results.repaint();
		}catch( Exception e ){
		}
		
	}
}
